import { Injectable } from '@nestjs/common';
import { BaseDeleteManager } from 'src/core/modules/domain/usecase/managers/base-delete.manager';
import { DataSchedulingEntity } from '../../entities/data-scheduling.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { DataSchedulingModel } from '../../../data/models/data-scheduling.model';
import { DataSchedulingDeletedEvent } from '../../entities/event/data-scheduling-deleted.event';

@Injectable()
export class DeleteDataSchedulingManager extends BaseDeleteManager<DataSchedulingEntity> {
  getResult(): string {
    return `Success`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return DataSchedulingModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: DataSchedulingDeletedEvent,
        data: this.data,
      },
    ];
  }
}
